const jsonServer = require("json-server");

const server = jsonServer.create();
const middlewares = jsonServer.defaults({
  static: "./build"
})

const router = jsonServer.router("database.json");

// return all tasks and links for the `gantt.load` method
server.get('/', (req, res, next) => {
  res.header('Access-Control-Allow-Origin', '*');
  var db = router.db.read()
  res.jsonp(db)
})

//redirect for adding new tasks and links
server.use(jsonServer.rewriter({
  '/task/*': '/data/$1',
  '/task': '/data',

  '/link/*': '/links/$1',
  '/link': '/links',
}))


//return the new task ID from the server to Gantt
router.render = (req, res, next) => {
  if (req.path === '/data') {
    if (res.locals.data.length !== 0) {
      var data = res.locals.data;
      data.action = "inserted"
      data.tid = data.id;
      res.status(201).jsonp(data);
    }
  } else {
    res.status(201).jsonp(res.locals.data);
  }
}


server.use(middlewares)
server.use(router)

const port = process.env.PORT || 4500

server.listen(port, () => {
  console.log(`JSON server is running, port: ${port}`)
})
