import React, { useState, useEffect } from 'react';
import GanttComponent from "./Gantt"
import RawData from "./RawData"
import Stats from "./Stats"

import './App.css';


const App = () => {
  let [activeTab, setTab] = useState(0);

  const handleTabChange = (index) => {

    setTab(activeTab = index);
  }
  const handleWheelTabChange = (e) => {
    const direction = e.deltaY / Math.abs(e.deltaY);
    const newTab = Math.abs(activeTab + direction) % 3;
    setTab(activeTab = newTab);
  }

  useEffect(() => {
    // console.log("Active tab",activeTab)
    document.title = `Active tab: ${document.querySelector(".selected").firstChild.nodeValue}`;
  });

  let Nav = () => {
    return (
      <nav className="App-nav" onClick={() => {
      }}>
        <ul>
          <li className={`App-nav-item ${activeTab === 0 && 'selected'}`} onClick={() => handleTabChange(0)} onWheel={(e) => handleWheelTabChange(e)} >
            Gantt
          </li>
          <li className={`App-nav-item ${activeTab === 1 && 'selected'}`} onClick={() => handleTabChange(1)} onWheel={(e) => handleWheelTabChange(e)}>
            Raw data
          </li>
          <li className={`App-nav-item ${activeTab === 2 && 'selected'}`} onClick={() => handleTabChange(2)} onWheel={(e) => handleWheelTabChange(e)}>
            Stats
          </li>
        </ul>
      </nav>
    )
  }

  let CurrentTab = () => {
    switch (activeTab) {
      default:
      case 0:
        return <GanttComponent></GanttComponent>
      case 1:
        return <RawData activeTab={activeTab}></RawData>
      case 2:
        return <Stats activeTab={activeTab}></Stats>
    }
  }

  return (
    <div className="App">
      <Nav></Nav>
      <CurrentTab></CurrentTab>
    </div>
  )
};


export default App;
